# change all newlines to ·newline·, everything is in one line
:a;N;$!ba;s/\n/·newline·/g;

# change "<" and ">" to html version
s/</\&lt;/g;
s/>/\&gt;/g;

# all spaces to html version
s/ /\&#xa0;/g;

# put defined values in one row with html table tag
s/\(#define\&#xa0;[A-Z0-9_]*\)\(\x09\|\&#xa0;\)*\([^·]*\)·newline·/<table cellpadding=0 cellspacing=0><tr><td width=300>\1<\/td><td>\3<\/td><\/tr><\/table>\n/g;

# make "..." red
s/"\([^·]*\)"/<span style='color:#800000;'>\&#34;\1\&#34;<\/span>/g;

# make <...> red
s/\(\&lt;[a-z\/]*\.h\&gt;\)/<span style='color:#800000;'>\1<\/span>/g;

# make preprocessor commands blue
s/\(#\(define\|ifdef\|ifndef\|if\|else\|else if\|include\)\)/<span style='color:#000080;'>\1<\/span>/g;

# change tabulators to four spaces
s/\x09/\&#xa0;\&#xa0;\&#xa0;\&#xa0;/g;

# make // comments green
s/\(\/\/[^·]*·newline·\)/<span style='color:#008000;'>\1<\/span>/g;

# make /* ... */ comments green
s/\/\*/<span style='color:#008000;'>\/\*/g;
s/\*\//\*\/<\/span>/g;

# make known variable types blue
s/\(\bint\b\|\bvoid\b\|\buint8_t\b\|\buint16_t\b\|\buint32_t\b\|\bchar\b\|\breturn\b\)/<span style='color:#000080;'>\1<\/span>/g;

# change ·newline· to html newlines
s/·newline·/<br>\n/g;

p;
